=== debian/changelog ===
scantailor-universal (0.2.9-0ubuntu1) bionic; urgency=medium

  * Ellipse zones in Output processing stage
  * Allow to optionally remove input files too in pages remove dialog
  * Improve Zone dragging behaviour
  * Bugfixes

 -- Alexander Trufanov <trufanovan@gmail.com>  Fri, 14 Nov 2020 22:50:00 +0300
 

scantailor-universal (0.2.8-0ubuntu1) bionic; urgency=medium

  * First release on launchpad

 -- Alexander Trufanov <trufanovan@gmail.com>  Fri, 13 Nov 2020 00:03:41 +0300
