=== debian/control ===
Source: scantailor-universal
Section: graphics
Priority: optional
Maintainer: Alexander Trufanov <trufanovan@gmail.com>
Build-Depends: debhelper-compat (= 9), qtbase5-dev (>=5.4), libtiff5-dev (>=4.0.3), libjpeg8-dev (>=8c), libgcc1 (>=1.3.0), libc6 (>=2.14), libpng-dev (>=1.6.2), libstdc++6 (>=5.2), qttools5-dev (>=5.4), libboost-dev (>=1.35.0), libboost-test-dev (>=1.35.0), cmake (>=2.8.9)
Standards-Version: 4.5.0
Homepage: https://github.com/trufanov-nok/scantailor-universal
#Vcs-Browser: https://salsa.debian.org/debian/scantailor-universal
#Vcs-Git: https://salsa.debian.org/debian/scantailor-universal.git
Rules-Requires-Root: no

Package: scantailor-universal
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: qttranslations5-l10n (>=5.4)
Description: Alternative version of ScanTailor: iinteractive post-processing tool for scanned pages
 Scan Tailor is an interactive post-processing tool for scanned pages. It
 performs operations such as page splitting, deskewing, adding/removing
 borders, and others. You give it raw scans, and you get pages ready to be
 printed or assembled into a PDF or DJVU file. Scanning, optical character
 recognition, and assembling multi-page documents are out of scope of this
 project.
