=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

%:
	dh $@

# override dh_auto_test bcs of this bug: https://askubuntu.com/questions/1287947/making-deb-with-bzr-qapplication-dependency
override_dh_auto_test:
